package com.kb.dao;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.kb.model.Employee;

@Repository
public class EmployeeDAOImpl implements EmployeeDAO{
	
	@Autowired
	 private SessionFactory sessionFactory;
	

	@SuppressWarnings("unchecked")
	@Override
	public List<Employee> listEmployees() {
		Session session = sessionFactory.openSession();
		List<Employee> EmployeesList = session.createQuery("from Employee").list();
		return EmployeesList;
	}
	
	public void insertSampleEmployees(){
		// Get session from Sesson factory
		Session session = sessionFactory.openSession();

		// Begin transaction
		Transaction t = session.beginTransaction();
		
		//Create Employee  data
		Employee employee1 = new Employee();
		employee1.setFirstName("John");
		employee1.setLastName("KC");
		employee1.setAge(28);
		employee1.setEducation("PG");
		employee1.setSalary(25000d);
		
		Employee employee2 = new Employee();
		employee2.setFirstName("Jacob");
		employee2.setLastName("JC");
		employee2.setAge(30);
		employee2.setEducation("PG");
		employee2.setSalary(30000d);
		
		Employee employee3 = new Employee();
		employee3.setFirstName("Martin");
		employee3.setLastName("A");
		employee3.setAge(24);
		employee3.setEducation("UG");
		employee3.setSalary(20000d);
		
		Employee employee4 = new Employee();
		employee4.setFirstName("Peter");
		employee4.setLastName("M");
		employee4.setAge(25);
		employee4.setEducation("UG");
		employee4.setSalary(22000d);
		
		Employee employee5 = new Employee();
		employee5.setFirstName("Roshan");
		employee5.setLastName("B");
		employee5.setAge(29);
		employee5.setEducation("PG");
		employee5.setSalary(45000d);
		
		
		session.save(employee1);
		session.save(employee2);
		session.save(employee3);
		session.save(employee4);
		session.save(employee5);

		t.commit();
		
		session.close();
	}

}
